<template>
    <div>
        <div class="content">
            <div class="container-fluid">
                <!--~~~~~~~ TABLE ONE ~~~~~~~~~-->
                <div
                    class="_1adminOverveiw_table_recent _box_shadow _border_radious _mar_b30 _p20"
                >
                    <p class="_title0" style="width:300px">
                        Role Manangement
                        <Select
                            v-model="data.id"
                            placeholder="Select Admin Type"
                            @on-change="changeAdmin"
                        >
                            <!-- <Option v-for="item in cityList" :value="item.value" :key="item.value">{{ item.label }}</Option> -->
                            <Option
                                :value="role.id"
                                v-for="(role, i) in roles"
                                :key="i"
                                >{{ role.roleName }}</Option
                            >
                            <!-- <Option value="Editor">Editor</Option> -->
                        </Select>
                    </p>

                    <div class="_overflow _table_div">
                        <table class="_table">
                            <!-- TABLE TITLE -->
                            <tr>
                                <th>Resource Name</th>
                                <th>Read</th>
                                <th>Write</th>
                                <th>Update</th>
                                <th>Delete</th>
                            </tr>
                            <!-- TABLE TITLE -->
                            <!-- ITEMS -->
                            <tr v-for="(r, i) in resource" :key="i">
                                <th style="color:#000000">
                                    {{ r.resourceName }}
                                </th>
                                <th><Checkbox v-model="r.read"></Checkbox></th>
                                <th><Checkbox v-model="r.write"></Checkbox></th>
                                <th>
                                    <Checkbox v-model="r.update"></Checkbox>
                                </th>
                                <th>
                                    <Checkbox v-model="r.delete"></Checkbox>
                                </th>
                            </tr>
                            <!-- ITEMS -->
                            <div class="center-button" style="margin-top:10px">
                                <Button
                                    :loading="isSendding"
                                    :disabled="isSendding"
                                    @click="assignRoles"
                                    type="primary"
                                >
                                    Assign</Button
                                >
                            </div>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    data() {
        return {
            data: {
                id: null
            },
            roles: [],
            isSendding: false,
            resource: [
                {
                    resourceName: "Home",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "/"
                },
                {
                    resourceName: "Tags",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "tags"
                },
                {
                    resourceName: "Category",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "category"
                },
                {
                    resourceName: "Create Blogs",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "createBlog"
                },
                {
                    resourceName: "Admin Users",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "adminusers"
                },
                {
                    resourceName: "Assign Role",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "assignRole"
                }
            ],
            defaultResource: [
                {
                    resourceName: "Home",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "/"
                },
                {
                    resourceName: "Tags",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "tags"
                },
                {
                    resourceName: "Category",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "category"
                },
                {
                    resourceName: "Category Blogs",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "categoryBlog"
                },
                {
                    resourceName: "Admin Users",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "adminusers"
                },
                {
                    resourceName: "Assign Role",
                    read: false,
                    write: false,
                    update: false,
                    delete: false,
                    name: "assignRole"
                }
            ]
        };
    },

    methods: {
        async assignRoles() {
            let data = JSON.stringify(this.resource);
            const res = await this.callApi("post", "app/assignRole", {
                permission: data,
                id: this.data.id
            });
            if (res.status == 200) {
                this.s("Role has been added successfully");
            } else {
                this.swr();
            }
        },
        changeAdmin() {
            let index = this.roles.findIndex(role => role.id == this.data.id);
            let permission = this.roles[index].permission;
            if (!permission) {
                this.resource = this.defaultResource;
            } else {
                this.resource = JSON.parse(permission);
            }

            //            console.log(permission);
            //console.log(this.data.id);
            //console.log(this.roles);
        }
    },
    async created() {
        const res = await this.callApi("get", "app/get_roles");
        if (res.status === 200) {
            console.log(res);
            this.roles = res.data;
            if (res.data.length) {
                this.data.id = res.data[0].id;
                if (res.data[0].permission) {
                    this.resource = JSON.parse(res.data[0].permission);
                }
            }
        } else {
            this.swr();
        }
    }
};
</script>
